// Un cylindre

float a = 0, b=2*PI; // intervalle u
float c = 0, d = 2*PI; // intervalle v
int n = 20, m = 40; // n = nombre de division de [a, b], m idem pour [c, d]

// Les couleurs
float couleur1R = 255;
float couleur1G = 0;
float couleur1B = 0; 
float couleur2R = 0;
float couleur2G = 255;
float couleur2B = 0;

float du = (b-a)/n; // accroissement sur u pour passer d'un sommet à l'autre
float dv = (d-c)/m; // accroissement sur v pour passer d'un sommet à l'autre

void definirFigure(){
  pixelsParUnite(20);
  // Calcul des sommets
  for(int i = 0; i <= n; i++){
    for(int j = 0; j <= m; j++){
      definirSommet(i*(m+1)+j+1, f(a+i*du, c+j*dv), g(a+i*du, c+j*dv), h(a+i*du, c+j*dv));
      //println(i*(m+1)+j+1);
    }//j
  }//i
  int ecart = n*m;
  for(int i=0; i < n; i++){
    for(int j = 0; j< m; j++){
      definirFace(i*(m+1)+j+1-i, i*(m+1)+j+1, i*(m+1)+j+2, (i+1)*(m+1)+j+1);
      definirFace(ecart+i*(m+1)+j+1-i, i*(m+1)+j+2, (i+1)*(m+1)+j+2, (i+1)*(m+1)+j+1);
      if ((i+j)%2 == 0){
        couleurFace(i*(m+1)+j+1-i, couleur1R, couleur1G, couleur1B);
        couleurFace(i*(m+1)+j+1-i+ecart, couleur1R, couleur1G, couleur1B);
      }else{
        couleurFace(i*(m+1)+j+1-i, couleur2R, couleur2G, couleur2B);
        couleurFace(i*(m+1)+j+1-i+ecart, couleur2R, couleur2G, couleur2B);
      }
    }//j
  }//i
}

void initialiserFigure(){
  fixeRotationX(30);
  fixeRotationY(25);
}

void redefinirCertainsSommets(){
  
}

// les fonctions coordonnées
float f(float u, float v){
  if(v < PI){
    return 3*cos(v)*(1+sin(v))+(2-cos(v))*cos(v)*cos(u);
  }else{
    return 3*cos(v)*(1+sin(v))+(2-cos(v))*cos(u+PI);
  }
}

float g(float u, float v){
  return (cos(v)-2)*sin(u);
}

float h(float u, float v){
  if(v < PI){
    return -8*sin(v)-(2-cos(v))*sin(v)*cos(u);
  }else{
    return -8*sin(v);
  }
}
